[Libguestfs] [PATCH v8 3/3] lib: Added filesystem_walk command tests

Richard W.M. Jones rjones at redhat.com
Wed Jun 15 14:07:05 UTC 2016


On Mon, Jun 13, 2016 at 07:50:54PM +0300, Matteo Cafasso wrote:
> The tests check whether the filesystem_walk command is able to retrieve
> information regarding both existing and deleted files.
> 
> A NTFS image is used as Ext3+ filesystems deletion is more aggressive
> in terms of metadata removal.
> 
> Signed-off-by: Matteo Cafasso <noxdafox at gmail.com>
> ---
>  tests/tsk/Makefile.am             |  3 +-
>  tests/tsk/test-filesystem-walk.sh | 64 +++++++++++++++++++++++++++++++++++++++
>  2 files changed, 66 insertions(+), 1 deletion(-)
>  create mode 100755 tests/tsk/test-filesystem-walk.sh
> 
> diff --git a/tests/tsk/Makefile.am b/tests/tsk/Makefile.am
> index 0cd7c03..f9b2fef 100644
> --- a/tests/tsk/Makefile.am
> +++ b/tests/tsk/Makefile.am
> @@ -18,7 +18,8 @@
>  include $(top_srcdir)/subdir-rules.mk
> 
>  TESTS = \
> -	test-download-inode.sh
> +	test-download-inode.sh \
> +	test-filesystem-walk.sh
> 
>  TESTS_ENVIRONMENT = $(top_builddir)/run --test
> 
> diff --git a/tests/tsk/test-filesystem-walk.sh b/tests/tsk/test-filesystem-walk.sh
> new file mode 100755
> index 0000000..c57f979
> --- /dev/null
> +++ b/tests/tsk/test-filesystem-walk.sh
> @@ -0,0 +1,64 @@
> +#!/bin/bash -
> +# libguestfs
> +# Copyright (C) 2016 Red Hat Inc.
> +#
> +# This program is free software; you can redistribute it and/or modify
> +# it under the terms of the GNU General Public License as published by
> +# the Free Software Foundation; either version 2 of the License, or
> +# (at your option) any later version.
> +#
> +# This program is distributed in the hope that it will be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write to the Free Software
> +# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
> +
> +# Test the filesystem-walk command.
> +
> +if [ -n "$SKIP_TEST_FILESYSTEM_WALK_SH" ]; then
> +    echo "$0: test skipped because environment variable is set."
> +    exit 77
> +fi
> +
> +# Skip if TSK is not supported by the appliance.
> +if ! guestfish add /dev/null : run : available "libtsk"; then
> +    echo "$0: skipped because TSK is not available in the appliance"
> +    exit 77
> +fi
> +
> +if [ ! -s ../../test-data/phony-guests/windows.img ]; then
> +    echo "$0: skipped because windows.img is zero-sized"
> +    exit 77
> +fi
> +
> +output=$(
> +guestfish --ro -a ../../test-data/phony-guests/windows.img <<EOF
> +run
> +mount /dev/sda2 /
> +write /test.txt "foobar"
> +rm /test.txt
> +umount /
> +filesystem-walk /dev/sda2
> +EOF
> +)
> +
> +# test $MFT is in the list
> +echo $output | grep -zq "{ tsk_inode: 0 tsk_type: r tsk_size: .* tsk_name: \$MFT tsk_flags: 1 }"
> +if [ $? != 0 ]; then
> +    echo "$0: \$MFT not found in files list."
> +    echo "File list:"
> +    echo $output
> +    exit 1
> +fi
> +
> +# test deleted file is in the list
> +echo $output | grep -zq "{ tsk_inode: .* tsk_type: [ru] tsk_size: .* tsk_name: test.txt tsk_flags: 0 }"
> +if [ $? != 0 ]; then
> +    echo "$0: /test.txt not found in files list."
> +    echo "File list:"
> +    echo $output
> +    exit 1
> +fi

This one looks OK.

Rich.

-- 
Richard Jones, Virtualization Group, Red Hat http://people.redhat.com/~rjones
Read my programming and virtualization blog: http://rwmj.wordpress.com
virt-p2v converts physical machines to virtual machines.  Boot with a
live CD or over the network (PXE) and turn machines into KVM guests.
http://libguestfs.org/virt-v2v




More information about the Libguestfs mailing list